%bcond_with iowatcher

Summary:  Utilities for performing block layer IO tracing in the Linux kernel
Name:     blktrace
Version:  1.3.0
Release:  3%{?dist}
License:  GPLv2+
URL:      https://brick.kernel.dk/snaps
Source0:  https://brick.kernel.dk/snaps/%{name}-%{version}.tar.bz2

BuildRequires: make gcc libaio-devel librsvg2-devel python3-devel
Requires: librsvg2-tools

%description
blktrace is a block layer IO tracing mechanism which provides detailed 
information about request queue operations up to user space. There are 
three major components: a kernel component, a utility to record the i/o 
trace information for the kernel to user space, and utilities to analyse 
and view the trace information.

%if %{with iowatcher}
%package -n iowatcher
Summary: Utility for creating visualizations from blktrace results
Requires: blktrace sysstat theora-tools

%description -n iowatcher
iowatcher graphs the results of a blktrace run. It can graph the result of an 
existing blktrace, start a new blktrace, or start a new blktrace and a benchmark 
run. It can then create an image or movie of the IO from a given trace. iowatcher 
can produce either SVG files or movies in mp4 format (with ffmpeg) or ogg format 
(with png2theora).
%endif

%prep
%autosetup
pathfix.py -i %{__python3} -pn btt/bno_plot.py btt/btt_plot.py

%build
%make_build CFLAGS="%{optflags} %{build_ldflags}" all

%install
make prefix=%{buildroot}%{_prefix} mandir=%{buildroot}%{_mandir} install

%if %{without iowatcher}
rm -f %{buildroot}%{_bindir}/iowatcher
rm -f %{buildroot}%{_mandir}/man1/iowatcher.1
%endif

%files
%license COPYING
%doc README
%{_bindir}/blkparse
%{_bindir}/blkrawverify
%{_bindir}/bno_plot.py
%{_bindir}/btt
%{_bindir}/verify_blkparse
%{_bindir}/blkiomon
%{_bindir}/blktrace
%{_bindir}/btrace
%{_bindir}/btrecord
%{_bindir}/btreplay
%{_mandir}/man1/blkparse.*
%{_mandir}/man1/blkrawverify.*
%{_mandir}/man1/bno_plot.*
%{_mandir}/man1/btt.*
%{_mandir}/man1/verify_blkparse.*
%{_mandir}/man8/blkiomon.*
%{_mandir}/man8/blktrace.*
%{_mandir}/man8/btrace.*
%{_mandir}/man8/btrecord.*
%{_mandir}/man8/btreplay.*

%if %{with iowatcher}
%files -n iowatcher
%license iowatcher/COPYING
%doc README
%{_bindir}/iowatcher
%{_mandir}/man1/iowatcher.*
%endif

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.0-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Jun 30 2022 Xiaojie Chen <jackxjchen@tencent.com> - 1.3.0-1
- Initial build
